package cz.cvut.wpa.servletdemo;

import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

/**
 *
 * @author kidney
 */
@WebFilter(filterName = "ChatSecurity", urlPatterns = "/chat")
public class ChatSecurity implements Filter {

    @Override
    public void init(FilterConfig fc) throws ServletException {
        // Do nothing
    }

    @Override
    public void doFilter(ServletRequest sr, ServletResponse sr1, FilterChain fc) throws IOException, ServletException {
        final HttpSession session = ((HttpServletRequest) sr).getSession(false);
        if (session == null) {
            throw new InvalidLoginException("User is not logged in.");
        }
        System.out.println("User session id: " + session.getAttribute("userSessionId"));
        fc.doFilter(sr, sr1);
    }

    @Override
    public void destroy() {
        // Do nothing
    }   
}
