package cz.cvut.wpa.servletdemo;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author kidney
 */
@WebServlet(name = "Chat", urlPatterns = "/chat")
public class ChatServlet extends HttpServlet {

    private static final List<String> messages = Collections.synchronizedList(new ArrayList<String>());

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        processRequest(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        processRequest(req, resp);
    }

    private void processRequest(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        resp.setContentType("text/html;charset=UTF-8");

        String message = req.getParameter("message");
        if (message != null) {
            messages.add(message);
        }

        final List<String> chatMessages = new ArrayList<>(messages);
        Collections.reverse(chatMessages);
        req.setAttribute("messages", chatMessages);

        RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/chat.jsp");
        dispatcher.forward(req, resp);
    }
}
